//
//  $Id: Database.h,v 1.4 2000/06/10 00:20:02 sergey Exp $
//

#ifndef _Database_h_
#define _Database_h_


namespace DB
{
    class AppInfo;
    class Record;

    //
    // Data Manager wrapper class
    //
    class Database
    {
    public:
        Database();
        ~Database();

    // this object can't be copied
    private:
        Database(const Database&);
        Database& operator =(const Database&);

    // operations
    public:
        bool open(int cardNo, const char* databaseName, int mode);
        void close();

        bool readAppInfo(AppInfo& appInfo) const;

        int recordCount() const;
        bool readRecord(int index, Record& record) const;

    // attributes

        bool isOpened() const           { return _openRef != 0; }

        bool isRecord(int index) const  { return 0 <= index && index < recordCount(); }
        bool isDeletedRecord(int index) const;

    // implementation
    protected:
        DmOpenRef openRef() const   { return _openRef; }

    // data members
    private:
        int _cardNo;
        DmOpenRef _openRef;
    };
}
// namespace DB

#endif // _Database_h_
